import 'package:flutter/material.dart';
import 'package:flutter_easyloading/flutter_easyloading.dart';
import 'package:flutter_screenutil/flutter_screenutil.dart';
import 'package:get/get.dart';
import 'package:worker_client/models/entities/Log.dart';
import 'package:worker_client/pages/wallet/widget/moneyInfo.dart';
import 'package:worker_client/services/account.dart';
import 'package:worker_client/widgets/MoneyCard/index.dart';
import 'package:worker_client/widgets/MyTitle/index.dart';
import 'package:worker_client/widgets/NullCard.dart';
import 'package:worker_client/widgets/layout/BasicPage.dart';

class MyWallet extends BasicPage {
  MyWallet({Key? key}) : super(key: key) {
    naviTitle = '我的钱包';
  }
  final amounts = Rx<double>(0);
  final logList = Rx<List<LogModel>>([]);
  @override
  void beforeShow() {
    super.beforeShow();
    EasyLoading.show(
      status: '数据加载中...',
      maskType: EasyLoadingMaskType.black,
    );
    getAccount().then((res) {
      amounts(double.parse(res['amounts'].toString()));

      getLogList({'pageNum': 1}).then((value) {
        var list = <LogModel>[];
        value['records'].forEach((item) {
          list.add(LogModel.fromJson(item));
        });
        logList(list);
        EasyLoading.dismiss();
      }).catchError((onError) => {
            EasyLoading.dismiss(),
          });
    }).catchError((onError) => {
          EasyLoading.dismiss(),
        });
  }

  void goWithDrawal() {
    Get.toNamed('/withdrawal',arguments: {'amounts':amounts.value});
  }

  @override
  Widget builder(BuildContext context) {
    return Container(
      decoration: const BoxDecoration(color: Colors.white),
      child: ListView(
        padding: EdgeInsets.all(15.w),
        children: [
          Obx(
            () => MoneyCard(
              amounts: amounts.value,
              goWithDrawal: () {
                goWithDrawal();
              },
            ),
          ),
          const MyTitle(title: '零钱明细'),
          Obx(() => logList.value != []
              ? Column(
                  children: logList.value
                      .map((e) => MoneyInfoCard(
                            logData: e,
                          ))
                      .toList(),
                )
              : const NullCard(text: '暂无明细')),
        ],
      ),
    );
  }
}
